



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>基于 HTML5 的 WebGL 3D 档案馆可视化管理系统</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">基于 HTML5 的 WebGL 3D 档案馆可视化管理系统</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 00:57:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>前言</h2>
<p>档案管理系统是通过建立统一的标准以规范整个文件管理，包括规范各业务系统的文件管理的完整的档案资源信息共享服务平台，主要实现档案流水化采集功能。为企事业单位的档案现代化管理，提供完整的解决方案，档案管理系统既可以自成系统，为用户提供完整的档案管理和网络查询功能，也可以与本单位的OA办公自动化和DPM设计过程管理，或者与MIS信息管理系统相结合，形成更加完善的现代化信息管理网络。传统档案馆随着社会的快速发展与变化，其内在形式上也发生了巨大变化，逐渐演变为现代智慧档案馆。智慧档案馆以现代科技为依托，充分结合现代物联网技术与云计算技术构建完善的城市智慧档案，实现了现代社会全面管理的目标。本文以当前流行的 H5 技术为主，为现代智慧档案馆提供一套 WEB 解决方案。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/591709/201809/591709-20180902233827618-275027955.gif" /></p>
<h2>代码实现</h2>
<h3>场景搭建</h3>
<p>在本例中，将使用 HT UI 组件对页面实现布局；使用 RelativeLayout 相对布局器将页面分为三个部分：left, top, center，使用 VBoxLayout 纵向布局器将 LEFT 部分分为 logo，editor，chart 三个部分<br /><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/591709/201809/591709-20180902232943891-846950229.png" /></p>
<h3>Graph3dView 加载 3D 场景</h3>
<p>Graph3dView 是 HT 组件中加载 3D 模型的拓扑组件，RelativeLayout 则是 HT 提供的 UI 解决方案，UI 组件中提供 HTView 组件来实现拓扑与 UI 的融合。</p>
<div>
<pre class="prettyprint linenums">    // 初始化相对布局器<br />
    var relativeLayout = new ht.ui.RelativeLayout();<br />
    // 初始化 3D 拓扑<br />
    var g3dView = new ht.graph3d.Graph3dView();<br />
    // 初始化 HTVIEW 组件， 并将 3D 拓扑放入其中<br />
    var htView = new ht.ui.HTView(g3dView);<br />
    // 布局器加载 HTVIEW 组件<br />
    relativeLayout.addView(htView, {<br />
        width: 'match_parent',  // 填满<br />
        height: 'match_parent', // 填满<br />
        marginTop: 64,            // 为 TOP 留下空间<br />
        marginLeft: 250            // 为 LEFT 留下空间<br />　　});</pre>
</div>
<h3><em><em>创建 LEFT 中的档案袋模型</em></em></h3>
<p><em><em> 左侧的 EDITOR 部分使用 HT 的调色板组件（ht.widget.Palette）, 将档案袋添加到调色板上，并设置为可以拖拽：<br /></em></em></p>
<div>
<pre class="prettyprint linenums">　　var palette = new ht.widget.Palette();<br />
    // palette 面板是将图元都分在&ldquo;组&rdquo;里面，然后向&ldquo;组&rdquo;中添加图元即可<br />
    var group = new ht.Group();<br />
    // 设置分组为打开的状态<br />
    group.setExpanded(true);<br />
    // 设置组的说明<br />
    group.setName('基础图元');<br />
    palette.dm().add(group);

    // 添加子图元<br />
    var childNode = new ht.Node();<br />
    childNode.setParent(group);<br />
    childNode.setName(name);<br />
    childNode.setImage(image);<br />
    childNode.s({<br />
        'draggable': true,                     // true 为可拖拽<br />
        'image.stretch': 'centerUniform'    // 图片申展方式<br />
    });<br />
    palette.dm().add(childNode);</pre>
</div>
<h3><em><em>实现从调色板中将图元拖拽至 3D 场景</em></em></h3>
<p><em><em> 在上一步中我们对调色板中的图元属性设置了可拖拽，此时可以实现拖拽图元的动画。但是并不能直接将图元拖拽到 3D 场景中，实现思路是：</p>
<p>1.&nbsp;&nbsp;在拖拽时获取拖拽的图元信息<br />2.&nbsp;&nbsp;拖拽到对应位置时显示可摆放位置<br />3.&nbsp;&nbsp;结束拖拽后在对应位置创建对应的 3D 模型</p>
<p>对应代码实现如下：</p>
<p>拖拽时获取图元信息</p>
<p></em></em></p>
<div>
<pre class="prettyprint linenums">g3dView.getView().addEventListener('dragover', function(e) {<br />
        e.preventDefault();<br />
        var paletteNode = palette.dm().sm().ld();// 获取 palette 上最后选中的节点<br />
        if (!paletteNode || !g3d.getDataAt(e)) return;

        // 获取鼠标下的节点<br />
        var data = g3d.getDataAt(e);<br />
        if (data.s('shape3d') === '档案柜.json') {<br />
            // 记录文件袋拖拽到的是哪个档案柜<br />
            g3dView._focusData = data;<br />
        }

    });</pre>
</div>
<p><em><em>拖拽到对应位置时创建 3D 模型，在实际实现过程中由于很难准确地获取到档案柜中每一个可以摆放档案袋的坐标位置，所以在本例中采用了预置的方法。具体原理就是在先创建一个正常不可见的档案柜模型，并在其中将档案袋都摆放完整，在拖拽时，将此不可见的模型与将要摆放的模型重合，此时只需判断鼠标所在的点下是否存在预置的模型存在就可以知道该处是否可以创建 3D 模型，实现效果如下：</em></em></p>
<p><em><em> <br /><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/591709/201809/591709-20180902233428332-121165454.gif" /></p>
<p></em></em></p>
<div>
<pre class="prettyprint linenums">g3dView.getView().addEventListener('dragover', function(e) {<br />
        ... // 旧逻辑省略

        // 拖拽下来的时候设置 所有的 displayName 为 box 的节点 为可见 （这样拖拽才能获取到预置模型）<br />
        array.forEach(function(data) {<br />
            data.s('3d.visible', true);<br />
        });

        var data = g3d.getDataAt(e);<br />
        if (data.s('shape3d') === '档案柜.json') {<br />
            // 记录文件袋拖拽到的是哪个档案柜<br />
            g3dView._focusData = data;

            // 将预置模型移动到拖拽的柜子坐标<br />
            shelf.p3(data.p3());<br />
        }

        if(data.getDisplayName() === 'box') {<br />
            // 将对应坐标下预置的档案袋模型进行显示<br />
            // 该属性可修改模型的透明度，更多属性可参考 HT 风格手册<br />
            data.s('shape3d.opacity',  0.8);<br />
        }<br />
        ...<br />
    })

    g3dView.getView().addEventListener('drop', function(e) {<br />
        // 获取鼠标位置模型<br />
        var data = g3dView.getDataAt(e);<br />
        if(!data) return;<br />
        // 鼠标位置不是预置模型，直接跳过<br />
        if(data.getDisplayName() !== 'box') return;<br />
        data.s('shape3d.opacity', 0);<br />
        // 放手时候设置 所有的 displayName 为 box 的节点 不可见<br />
        array.forEach(function(data) {<br />
            data.s('3d.visible', false);<br />
        });

        var node = new ht.Node();<br />
        node.s('shape3d', url); // 档案袋 3D 模型地址<br />
        node.r3([Math.PI/2, -Math.PI/2, 0]); // 旋转档案袋模型， 使其平放<br />
        node.p3(data.p3());<br />
        node.setParent(g3dView._focusData);<br />
        node.setHost(g3dView._focusData);<br />
    });</pre>
</div>
<p><em><em>&nbsp;</em></em></p>
<h3><em><em><em><em>档案柜虚化效果实现</em></em></em></em></h3>
<p><em><em> 上面我们已经实现了档案袋拖拽至 3D 场景的效果，但是我们可以发现档案袋模型远小于柜子，要将档案袋摆放到正确的位置并不是那么容易。所以此时我们可以将需要操作的档案柜放大到正中间，其它模型进行虚化处理。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/591709/201809/591709-20180902233522496-557558538.gif" /><br />
&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;</em></em></p>
<div>
<pre class="prettyprint linenums">　　// 3D 拓扑交互监听<br />
    g3dView.mi(function(e){<br />
        if(e.kind === 'doubleClickData') {<br />
            // 双击事件<br />
            var shape3d = e.data.s('shape3d'),<br />
                parentShape3d = e.data.getParent() &amp;&amp; e.data.getParent().s('shape3d');<br />
            if (shape3d &amp;&amp; shape3d.indexOf('档案柜') &gt; -1) {<br />
                // 重点突出档案柜<br />
                showDetail(e.data);<br />
            }<br />
            else if (parentShape3d &amp;&amp; parentShape3d.indexOf('档案柜') &gt; -1) {<br />
                showDetail(e.data.getParent());<br />
            }<br />
        }<br />
    });

    showDetail = function(data) {<br />
        // 保存进入虚化状态前 视角 与 中心点<br />
        eyeBack = ht.Default.clone(graph3dView.getEye());<br />
        centerBack = ht.Default.clone(graph3dView.getCenter());

        // 设置相机指向配置<br />
        var opt = {};<br />
        opt.animation = true;<br />
        opt.ratio = 1;<br />
        opt.direction = [1, 0.5, 0];<br />
        opt.center = [data.getX(), 100, data.getY()];

        graph3dView.flyTo(data, opt);<br />
        focusData = data;

        data.s('select.brightness', 1);<br />
        dataModel.each(function (d) {<br />
            if (d === focusData || (!d.s('3d.selectable') &amp;&amp; d.getTag() !== 'wall')<br />
                || d.getParent() === focusData || d.getDisplayName() === 'box') return;<br />
            // 将拓扑中除了要操作的柜子 与柜子中档案袋 以及墙外 透明度都设置为 opacity (0~1)

            // 保存设置前配置， 还原用<br />
            if (!opacityMap[d.getId()]) {<br />
                opacityMap[d.getId()] = {<br />
                    'shape3d.opacity': d.s('shape3d.opacity'),<br />
                    'shape3d.transparent': d.s('shape3d.transparent'),<br />
                    'all.opacity': d.s('all.opacity'),<br />
                    'all.transparent': d.s('all.transparent'),<br />
                    'left.opacity': d.s('left.opacity'),<br />
                    'left.transparent': d.s('left.transparent'),<br />
                    'right.opacity': d.s('right.opacity'),<br />
                    'right.transparent': d.s('right.transparent'),<br />
                    'front.opacity': d.s('front.opacity'),<br />
                    'front.transparent': d.s('front.transparent'),<br />
                    'back.opacity': d.s('back.opacity'),<br />
                    'back.transparent': d.s('back.transparent'),<br />
                    'top.opacity': d.s('top.opacity'),<br />
                    'top.transparent': d.s('top.transparent'),<br />
                    'bottom.opacity': d.s('bottom.opacity'),<br />
                    'bottom.transparent': d.s('bottom.transparent'),<br />
                    '3d.selectable': d.s('3d.selectable')<br />
                }<br />
            }

            // 透明度设置为 opacity<br />
            d.s({<br />
                'shape3d.opacity': opacity,<br />
                'shape3d.transparent': true,<br />
                'all.opacity': opacity,<br />
                'all.transparent': true,<br />
                'left.opacity': opacity,<br />
                'left.transparent': true,<br />
                'right.opacity': opacity,<br />
                'right.transparent': true,<br />
                'front.opacity': opacity,<br />
                'front.transparent': true,<br />
                'back.opacity': opacity,<br />
                'back.transparent': true,<br />
                'top.opacity': opacity,<br />
                'top.transparent': true,<br />
                'bottom.opacity': opacity,<br />
                'bottom.transparent': true,<br />
                '3d.selectable': false<br />
            });

        });<br />
    }</pre>
</div>
<p><em><em>退出虚化模式，以监控 3D 拓扑的选中变化来实现</em></em></p>
<div>
<pre class="prettyprint linenums">　　　　 g3dView.dm().ms(function(e) {<br />
        var lastData = g3dView.sm().ld();<br />
        // 判断是否进行虚化<br />
        if(focusData) {<br />
            if(lastData === focusData || (lastData &amp;&amp; lastData.getParetn() === focusData)) return;<br />
            g3dView.setEye(eyeBack);<br />
            g3dView.setCenter(centerBack);<br />
            // 还原模型的原透明度<br />
            g3dView.dm().each(function (d) {<br />
                if (d === focusData) return;<br />
                d.s(opacityMap[d.getId()]);<br />
            });

            focusData.s('select.brightness', 0.7);<br />
            focusData = null;<br />
            eyeBack = null;<br />
            centerBack = null;<br />
        }<br />
    });</pre>
</div>
<h3><em><em>快速查询功能实现</em></em></h3>
<p><em><em> 在 HT 的组件中有提供快速查询插件 QuickFinder ，此次我们就运用该插件来实现简单的档案编号查询<br /></em></em></p>
<div>
<pre class="prettyprint linenums">　　// 初始化 输入框<br />
    var textField = new ht.ui.TextField;<br />
    textField.setIcon("imgs/search.json");<br />
    textField.setIconPosition("left");

    // 初始化查询器，条件：id<br />
    var finder = new ht.QuickFinder(library.view.dm, "id");<br />
    // 输入框点击查询按钮时触发<br />
    textField.on('p:value', function(e) {<br />
        var dm = library.view.dm;<br />
        var value = e.newValue;<br />
        var datas = finder.find(value);<br />
        // 查询到对应的图元时，我们将第一个结果进行选中<br />
        if (datas &amp;&amp; datas.size() &gt; 0) {<br />
            library.view.dm.sm().ss(datas.get(0));<br />
        }<br />
    });</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/591709/201809/591709-20180902233714147-838769437.gif" /></p>
<h2><em><em><em><em>总结</em></em></em></em></h2>
<p><em><em> 经过以上功能的实现，一个基础的智慧档案管理系统就成形了。当然做为一个智慧管理系统，这些还是远远不够的，例如档案动态监控、档案室内人员走动监控、视频监控、温度监控、灾害报警等等模块都是后期可以完善的地方。这里只是简单地为大家提供了一个基于 HTML5 WEBGL 的 3D 解决方案。同样原理，智能楼宇、智能机房、智能城市也可以基于此来实现。</em></em></p>
<p><em><em>最终效果可查看：<a href="https://hightopo.com/demo/intelligent-archives/" rel="external nofollow noreferrer">https://hightopo.com/demo/intelligent-archives/</a><br /><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/591709/201809/591709-20180902233754447-727236652.gif" /><br /></em></em></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4ykx3q.html">app开发项目简单的结构一</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kv4e69.html">JavaScript 消息框&plus;特殊字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7vklgq.html">ACM  分数加减法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq10lez8.html">&lbrack;MetaHook&rsqb; Load large texture from model</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qypn1xq.html">linux tricks 之 bitmap分析&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zmmx59.html">Website English Comments</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1eon39.html">linux bash&lowbar;profile和&period;bashrc区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjyyr79.html">bzoj 3781&colon; 小B的询问 分块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdg06r8.html">彻底解决Unknown ASTNode child&colon;  LambdaExpression  错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05mxwq.html">C&num;获取文件和文件夹大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e410jx9.html">Python学习第七课</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjg2lz9.html">Learning-MySQL【4】：表的操作管理和 MySQL 的约束控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ryo739.html">easyUI使用dailog实现弹出框带表单功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1w6req.html">大数据处理算法--Bloom Filter布隆过滤</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj604j9.html">&num;9 &sol;&sol;&lbrack;SDOI2017&rsqb;新生舞会</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r06748.html">swift - 高斯模糊</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvwv1mq.html">BZOJ2815&colon;&lbrack;ZJOI2012&rsqb;灾难&lpar;拓扑排序&comma;LCA&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pg0knq.html">常用校验码（奇偶校验码、海明校验码、CRC校验码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn7p44q.html">自己实现简单的RSA秘钥生成与加解密&lpar;Java &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn3wx4q.html">Python 各种库的安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv16j3xq.html">Smobiler 4&period;4已正式发布！（Smobiler能让你在Visual Studio上开发APP）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eynrgx9.html">&lbrack;PHP&rsqb; yield沟通函数循环内外</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpn11xq.html">关于Xcode9&period;0版本模拟器Reset重置操作变更</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zod7m3q.html">kafka环境搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ye4jg8.html">深入理解Mysql索引的底层数据结构 B&plus; Tree （2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv16l3jq.html">炫龙炎魔T1笔记本 Win7 系统安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgexv48.html">OLW （Open Live Writer）安装代码高亮插件方法（简明）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jopjw8.html">5&period;6Python数据处理篇之Sympy系列&lpar;六&rpar;---矩阵的操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpyxn59.html">SQLServer之视图简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgevyr8.html">SQLServer之创建DML AFTER INSERT触发器</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
